diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelSignPainted.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelSignPainted.java
new file mode 100644
index 000000000..c7eb9ee08
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelSignPainted.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.render.item.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+
+public class ItemModelSignPainted extends ItemModelStandard {
+    public static IconCoordinate[] sign = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+    static {
+        for (DyeColor c : DyeColor.itemOrderedColors()){
+            sign[c.itemMeta] = TextureRegistry.getTexture("minecraft:item/sign/" + c.colorID);
+        }
+    }
+    public ItemModelSignPainted(Item item) {
+        super(item, null);
+    }
+    public @NotNull IconCoordinate getIcon(Entity entity, ItemStack itemStack){
+        int meta = itemStack.getMetadata();
+        return sign[meta & DyeColor.MASK_COLOR];
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/TextureFile.java b/game/client/src/main/java/net/minecraft/client/render/texture/TextureFile.java
index ee65211e2..69b4353c3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/TextureFile.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/TextureFile.java
@@ -62,6 +62,12 @@ public class TextureFile extends Texture{
             try (final InputStream stream = pack.getResourceAsStream(this.sourcePath + ".mcmeta")) {
                 if (stream != null) {
                     this.metaHandler.loadFromStream(stream);
+                } else {
+                    try (InputStream stream2 = mc.texturePackList.getDefaultTexturePack().getResourceAsStream(sourcePath + ".mcmeta")) {
+                        if (stream2 != null) {
+                            this.metaHandler.loadFromStream(stream2);
+                        }
+                    }
                 }
             } catch (final Exception e) {
                 LOGGER.error("Failed to load data for '{}.mcmeta'!", this.sourcePath, e);
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 9754a6056..3fdff365e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -9,9 +9,12 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicSign;
+import net.minecraft.core.block.BlockLogicSignPainted;
+import net.minecraft.core.block.IPainted;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
@@ -23,9 +26,13 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 
     private final Minecraft mc = Minecraft.getMinecraft();
     private final @NotNull StringBuilder builder = new StringBuilder();
+    private final String[] signColorTextures = new String[16];
 
     public TileEntityRendererSign() {
         super();
+        for (int i = 0; i < signColorTextures.length; i++) {
+            signColorTextures[i] = "/assets/minecraft/textures/entity/sign/" + DyeColor.colorFromBlockMeta(i).colorID + ".png";
+        }
     }
 
      @Override
@@ -41,14 +48,15 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         final float scale = 2/3f * 1/16f;
         final float height;
         GL11.glTranslatef((float)x + 0.5F, (float)y, (float)z + 0.5F);
+        final int meta = tileEntity.getBlockMeta();
         if (((BlockLogicSign) block.getLogic()).isFreeStanding) {
-            final float angle = (float)(tileEntity.getBlockMeta() * 360) / 16F;
+            final float angle = (float)((meta & BlockLogicSign.MASK_SIDE) * 360) / 16F;
             GL11.glRotatef(-angle, 0.0F, 1.0F, 0.0F);
             model = getModel("post");
             height = 20;
         } else {
             final float angle;
-            switch (tileEntity.getBlockMeta()) {
+            switch (meta & BlockLogicSign.MASK_SIDE) {
                 case BlockLogicSign.SIDE_NORTH:
                     angle = 180F;
                     break;
@@ -71,17 +79,29 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 
         GL11.glPushMatrix();
         GL11.glScalef(scale, scale, -scale);
-        bindTexture("/assets/minecraft/textures/entity/sign.png");
+        int colorSign;
+        if (Block.hasLogicClass(block, BlockLogicSignPainted.class)) {
+            DyeColor c = ((IPainted) block.getLogic()).fromMetadata(meta);
+            bindTexture(this.signColorTextures[c.blockMeta]);
+            colorSign = c.color.getARGB();
+        } else {
+            bindTexture("/assets/minecraft/textures/entity/sign.png");
+//            colorSign = 0xa57319;
+            colorSign = 0x695e43;
+        }
         model.render(t);
         GL11.glPopMatrix();
 
+
+
         // Render overlay
         GL11.glPushMatrix();
+        GL11.glEnable(GL11.GL_BLEND);
         GL11.glTranslatef(0 * scale, height * scale, 1.05f * scale);
         GL11.glNormal3f(0, 0, 1);
         GL11.glDepthMask(false);
         final EnumSignPicture picture = tileEntity.getPicture();
-        drawTexturedModalRect(1, 0.5,TextureRegistry.getTexture(picture.getTextureKey()));
+        drawTexturedModalRect(1, 0.5, colorSign,TextureRegistry.getTexture(picture.getTextureKey()));
         GL11.glPopMatrix();
 
         // Render text
@@ -102,21 +122,35 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
          GL11.glTranslatef(0.0F, height * scale, 1.1f * scale);
          GL11.glScalef(scale2, -scale2, scale2);
          GL11.glDepthMask(false);
-        int color = Colors.allSignColors[tileEntity.getColor().id].getARGB();
+         int color = Colors.allSignColors[tileEntity.getColor().id].getARGB();
         final int r = (int) MathHelper.clamp((Color.redFromInt(color) * lightLevel + lightOffset), 0, 255);
         final int g = (int)MathHelper.clamp((Color.greenFromInt(color) * lightLevel + lightOffset), 0, 255);
         final int b = (int)MathHelper.clamp((Color.blueFromInt(color) * lightLevel + lightOffset), 0, 255);
+        final int borderR = (int) MathHelper.clamp((Color.redFromInt(color) * lightLevel - 127), 0, 255);
+        final int borderG = (int) MathHelper.clamp((Color.greenFromInt(color) * lightLevel - 127), 0, 255);
+        final int borderB = (int) MathHelper.clamp((Color.blueFromInt(color) * lightLevel - 127), 0, 255);
         color = Color.intToIntARGB(0, r, g, b);
+        int borderColor = Color.intToIntARGB(0, borderR, borderG, borderB);
         for(int line = 0; line < tileEntity.signText.length; line++)
         {
             this.builder.setLength(0);
             if(line == tileEntity.lineBeingEdited)
             {
-                this.builder.append("§+§0> §-").append(tileEntity.signText[line]).append("§+§0 <§-");
+                this.builder.append("§+§f> §-").append(tileEntity.signText[line]).append("§+§f <§-");
             } else {
                 this.builder.append(tileEntity.signText[line]);
             }
-            sr.render(t, this.builder, -sr.stringWidth(this.builder) / 2, line * 10 - tileEntity.signText.length * 5).setColor(color).call();
+            int _x = -sr.stringWidth(this.builder) / 2;
+            int _y = line * 10 - tileEntity.signText.length * 5;
+            if (tileEntity.isGlowing()) {
+                int _x2 = -sr.stringWidth(tileEntity.signText[line]) / 2;
+                for (float i = -1; i <= 1; i += 1/3f) {
+                    for (float j = -1; j <= 1; j += 1/3f) {
+                        sr.renderDouble(t, tileEntity.signText[line], _x2 + i, _y + j).setColor(borderColor).call();
+                    }
+                }
+            }
+            sr.render(t, this.builder, _x, _y).setColor(color).call();
         }
         GL11.glPopMatrix();
 
@@ -126,11 +160,12 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
-    private static void drawTexturedModalRect(final double width, final double height, final @NotNull IconCoordinate coordinate)
+    private static void drawTexturedModalRect(final double width, final double height, int color, final @NotNull IconCoordinate coordinate)
     {
         coordinate.parentAtlas.bind();
         final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
+        tessellator.setColorRGBA_I(color, 128);
         tessellator.addVertexWithUV(-width/2,  height/2, 0, coordinate.getIconUMin(),coordinate.getIconVMin());
         tessellator.addVertexWithUV(-width/2, -height/2, 0, coordinate.getIconUMin(),coordinate.getIconVMax());
         tessellator.addVertexWithUV( width/2, -height/2, 0, coordinate.getIconUMax(),coordinate.getIconVMax());
diff --git a/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java b/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
index 23be97302..9d9dccc91 100644
--- a/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
@@ -171,7 +171,6 @@ public class SoundEngine
 	public void playSound(final SoundEntry entry, final SoundCategory category, final float volume, final float pitch) {
 		try {
 			lock.lock();
-			if (!canPlaySounds()) return;
 			this.idCounter = (this.idCounter + 1) % 256;
 			final String soundName = "sound_" + this.idCounter;
 			playSoundWithID(entry, category, volume, pitch, soundName);
@@ -187,7 +186,6 @@ public class SoundEngine
 	public void playSoundAt(final SoundEntry entry, final SoundCategory category, final float x, final float y, final float z, final float volume, final float pitch) {
 		try {
 			lock.lock();
-			if (!canPlaySounds()) return;
 			this.idCounter = (this.idCounter + 1) % 256;
 			final String soundName = "sound_" + this.idCounter;
 			playSoundWithIdAtPos(entry, category, x, y, z, volume, pitch, soundName);
@@ -211,27 +209,28 @@ public class SoundEngine
 	private void playSoundWithID(final SoundEntry entry, final SoundCategory category, float volume, final float pitch, final String soundID, final boolean allowSubtitle) {
 		try {
 			lock.lock();
-			if (!canPlaySounds()) return;
 			if (entry != null) {
-				if (entry.type == SoundEntry.Type.FILE) {
-					final URL url = entry.getURL();
-					if (url != null){
-						if (entry.shouldStream) {
-							soundSystem.newStreamingSource(false, soundID, url, entry.name, false, 0, 0, 0, 2, 0);
-						} else {
-							soundSystem.newSource(false, soundID, url, entry.name, false, 0, 0, 0, 0, 0);
-						}
-						if (volume > 1.0F)
-						{
-							volume = 1.0F;
+				if (canPlaySounds()) {
+					if (entry.type == SoundEntry.Type.FILE) {
+						final URL url = entry.getURL();
+						if (url != null){
+							if (entry.shouldStream) {
+								soundSystem.newStreamingSource(false, soundID, url, entry.name, false, 0, 0, 0, 2, 0);
+							} else {
+								soundSystem.newSource(false, soundID, url, entry.name, false, 0, 0, 0, 0, 0);
+							}
+							if (volume > 1.0F)
+							{
+								volume = 1.0F;
+							}
+							volume *= 0.25F;
+							soundSystem.setPitch(soundID, pitch * entry.pitch);
+							soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category, this.options) * entry.volume);
+							soundSystem.play(soundID);
 						}
-						volume *= 0.25F;
-						soundSystem.setPitch(soundID, pitch * entry.pitch);
-						soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category, this.options) * entry.volume);
-						soundSystem.play(soundID);
+					} else if (entry.type == SoundEntry.Type.EVENT) {
+						playSoundWithID(entry.name, category, volume * entry.volume, pitch * entry.pitch, soundID, false);
 					}
-				} else if (entry.type == SoundEntry.Type.EVENT) {
-					playSoundWithID(entry.name, category, volume * entry.volume, pitch * entry.pitch, soundID, false);
 				}
 				if (allowSubtitle && entry.parent.hasSubtitle()) {
 					this.mc.subtitleTracker.heardSound(entry.parent, 0, 0, 0);
@@ -256,7 +255,6 @@ public class SoundEngine
 	private void playSoundWithIdAtPos(final SoundEntry entry, final SoundCategory category, final float x, final float y, final float z, float volume, final float pitch, final String soundID, final boolean allowSubtitle) {
 		try {
 			lock.lock();
-			if (!canPlaySounds()) return;
 			if (entry != null) {
 				float soundDistance = entry.attenuationDistance;
 				if(volume > 1.0F)
@@ -265,24 +263,26 @@ public class SoundEngine
 				}
 				if(this.mc.activeCamera.distanceToSqr(x, y, z) > (double)(soundDistance * soundDistance)) return;
 
-				if (entry.type == SoundEntry.Type.FILE) {
-					final URL url = entry.getURL();
-					if (url != null){
-						if (entry.shouldStream) {
-							soundSystem.newStreamingSource(volume > 1.0F, soundID, url, entry.name, false, x, y, z, 2, soundDistance);
-						} else {
-							soundSystem.newSource(volume > 1.0F, soundID, url, entry.name, false, x, y, z, 2, soundDistance);
+				if (canPlaySounds()) {
+					if (entry.type == SoundEntry.Type.FILE) {
+						final URL url = entry.getURL();
+						if (url != null){
+							if (entry.shouldStream) {
+								soundSystem.newStreamingSource(volume > 1.0F, soundID, url, entry.name, false, x, y, z, 2, soundDistance);
+							} else {
+								soundSystem.newSource(volume > 1.0F, soundID, url, entry.name, false, x, y, z, 2, soundDistance);
+							}
+							if (volume > 1.0F) {
+								volume = 1.0F;
+							}
+
+							soundSystem.setPitch(soundID, pitch * entry.pitch);
+							soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category, this.options) * entry.volume);
+							soundSystem.play(soundID);
 						}
-						if (volume > 1.0F) {
-							volume = 1.0F;
-						}
-
-						soundSystem.setPitch(soundID, pitch * entry.pitch);
-						soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category, this.options) * entry.volume);
-						soundSystem.play(soundID);
+					} else if (entry.type == SoundEntry.Type.EVENT) {
+						playSoundWithIdAtPos(entry.name, category, x, y, z, volume * entry.volume, pitch * entry.pitch, soundID, false);
 					}
-				} else if (entry.type == SoundEntry.Type.EVENT) {
-					playSoundWithIdAtPos(entry.name, category, x, y, z, volume * entry.volume, pitch * entry.pitch, soundID, false);
 				}
 				if (allowSubtitle && entry.parent.hasSubtitle()) {
 					this.mc.subtitleTracker.heardSound(entry.parent, x, y, z);
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
index 2127c1808..62b0c16da 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
@@ -128,6 +128,9 @@ public class ItemDragHandler extends Gui {
 	
 	public void mouseEvent(final int x, final int y, int button, boolean pressed) {
 		boolean shift = Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT);
+		if (button == 10) {
+			shift = true;
+		}
 		boolean control = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL);
 		boolean alt = Keyboard.isKeyDown(Keyboard.KEY_LMENU) || Keyboard.isKeyDown(Keyboard.KEY_RMENU);
 		boolean space = Keyboard.isKeyDown(Keyboard.KEY_SPACE);
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/JavaProcess.java b/game/client/src/main/java/net/minecraft/client/util/helper/JavaProcess.java
new file mode 100644
index 000000000..598002f99
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/JavaProcess.java
@@ -0,0 +1,39 @@
+package net.minecraft.client.util.helper;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.Collection;
+import java.util.LinkedList;
+import java.util.List;
+
+// From https://stackoverflow.com/questions/636367/executing-a-java-application-in-a-separate-process
+public final class JavaProcess {
+
+    private JavaProcess() {}
+
+    public static int exec(final Class klass, final Collection<String> args) throws IOException,
+        InterruptedException {
+        final String javaHome = System.getProperty("java.home");
+        final String javaBin = javaHome +
+            File.separator + "bin" +
+            File.separator + "java";
+        final String classpath = System.getProperty("java.class.path");
+        final String className = klass.getName();
+
+        final List<String> command = new LinkedList<>();
+        command.add(javaBin);
+        command.add("-cp");
+        command.add(classpath);
+        command.add(className);
+        if (args != null) {
+            command.addAll(args);
+        }
+
+        final ProcessBuilder builder = new ProcessBuilder(command);
+
+        final Process process = builder.inheritIO().start();
+        process.waitFor();
+        return process.exitValue();
+    }
+
+}
diff --git a/game/core/build.gradle.kts b/game/core/build.gradle.kts
index f764ce40f..c084dc811 100644
--- a/game/core/build.gradle.kts
+++ b/game/core/build.gradle.kts
@@ -21,6 +21,15 @@ run {
 repositories {
     mavenCentral()
     maven("https://libraries.minecraft.net/")
+
+    ivy {
+        url = uri("https://github.com/Better-than-Adventure")
+        patternLayout {
+            artifact("[organisation]/releases/download/[revision]/brigadier-[revision].jar")
+            m2Compatible
+        }
+        metadataSources { artifact() }
+    }
 }
 
 dependencies {
@@ -40,6 +49,7 @@ dependencies {
 
 }
 
+
 java {
     sourceCompatibility = JavaVersion.VERSION_1_8
     targetCompatibility = JavaVersion.VERSION_1_8
diff --git a/game/core/src/main/java/net/minecraft/core/BuildChannel.java b/game/core/src/main/java/net/minecraft/core/BuildChannel.java
index ea4e79ceb..3ed54d0d4 100644
--- a/game/core/src/main/java/net/minecraft/core/BuildChannel.java
+++ b/game/core/src/main/java/net/minecraft/core/BuildChannel.java
@@ -1,17 +1,17 @@
 package net.minecraft.core;
 
 public enum BuildChannel {
-    STABLE,
+    RELEASE,
     PRERELEASE,
     DEVELOPMENT,
     NIGHTLY;
 
     public boolean isUnstableBuild() {
-        return this != STABLE;
+        return this != RELEASE;
     }
 
     public String modifyVersionString(String version) {
-        if (this == STABLE || this == PRERELEASE) {
+        if (this == RELEASE || this == PRERELEASE) {
             return version;
         } else if (this == DEVELOPMENT) {
             return version + " INDEV";
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
index 1b8ffb04e..2df4076e4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
@@ -8,6 +8,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
@@ -54,7 +55,7 @@ public class BlockLogicBasket extends BlockLogic
     {
         final TileEntityBasket te = (TileEntityBasket) world.getTileEntity(x, y, z);
 
-        final float fill = te.getNumUnitsInside() / (float)te.getMaxUnits();
+        final float fill = MathHelper.clamp(te.getNumUnitsInside() / (float)te.getMaxUnits(), 0, 1); // Clamps the visual effect even if the basket gets overstuffed
 
         return (int) Math.ceil(10 * fill);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
index 8ad5f97f7..cbbf2dfc6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityChest;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
@@ -408,7 +409,8 @@ public class BlockLogicChest extends BlockLogic implements IPaintable {
 	@Override
 	public void setColor(World world, int x, int y, int z, DyeColor color) {
 		final int meta = world.getBlockMetadata(x, y, z);
-		world.setBlockAndMetadata(x, y, z, Blocks.CHEST_PLANKS_OAK_PAINTED.id(), meta);
+		world.setBlockAndMetadataRaw(x, y, z, Blocks.CHEST_PLANKS_OAK_PAINTED.id(), meta);
+		world.setBlockMetadata(x, y, z, meta);
 		Blocks.CHEST_PLANKS_OAK_PAINTED.getLogic().setColor(world, x, y, z, color);
 	}
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlowStone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlowStone.java
index 00691447e..9a6419f3c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlowStone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlowStone.java
@@ -25,7 +25,7 @@ public class BlockLogicGlowStone extends BlockLogic
             case SILK_TOUCH:
                 return new ItemStack[] { new ItemStack(this) };
             default:
-                return new ItemStack[] { new ItemStack(Items.DUST_GLOWSTONE, 2 + world.rand.nextInt(2)) };
+                return new ItemStack[] { new ItemStack(Items.DUST_GLOWSTONE, 4) };
         }
     }
     
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
index 081207a22..54ee250b7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
@@ -5,8 +5,11 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
@@ -53,6 +56,13 @@ public class BlockLogicLayerSnow extends BlockLogicLayerBase
         }
     }
 
+    @Override
+    public AABB getCollisionBoundingBoxFromPool(final WorldSource world, final int x, final int y, final int z) {
+        final AABB aabb = super.getCollisionBoundingBoxFromPool(world, x, y, z);
+        aabb.maxY = Math.max(aabb.maxY - 2/16f, y);
+        return aabb;
+    }
+
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
index 00f2150aa..9787d6a11 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
@@ -6,6 +6,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.world.generate.feature.WorldFeatureOre;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.HashMap;
@@ -14,7 +15,7 @@ import java.util.Map.Entry;
 import java.util.Random;
 
 public class BlockLogicMoss extends BlockLogic implements IBonemealable {
-	public static Map<Integer, Integer> variantMap = new HashMap<>();
+	public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
 	public BlockLogicMoss(Block<?> block, Block<?> parentBlock) {
 		super(block, Material.moss);
 		block.setTicking(true);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
index f8be60f35..858749eee 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
@@ -47,7 +47,7 @@ public class BlockLogicNote extends BlockLogic
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide) {
-            changePitch(world, x, y, z);
+            changePitch(world, x, y, z, player.isSneaking() ? -1 : 1);
             triggerNote(world, x, y, z);
         }
         return true;
@@ -55,7 +55,7 @@ public class BlockLogicNote extends BlockLogic
 
     @Override
     public void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction) {
-        changePitch(world, x, y, z);
+        changePitch(world, x, y, z, 1);
         triggerNote(world, x, y, z);
     }
 
@@ -67,9 +67,9 @@ public class BlockLogicNote extends BlockLogic
         }
     }
 
-    public void changePitch(World world, int x, int y, int z) {
+    public void changePitch(World world, int x, int y, int z, int delta) {
         int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockMetadata(x, y, z, setNote(meta, (getNote(meta) + 1) % (MAX_NOTE + 1)));
+        world.setBlockMetadata(x, y, z, setNote(meta, (getNote(meta) + (MAX_NOTE + 1) + delta) % (MAX_NOTE + 1)));
     }
 
     public void triggerNote(World world, int x, int y, int z) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreCoal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreCoal.java
index 4664fdd7a..7b638b37e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreCoal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreCoal.java
@@ -6,13 +6,14 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.WorldFeatureOre;
 
 import java.util.HashMap;
 import java.util.Map;
 
 public class BlockLogicOreCoal extends BlockLogic
 {
-    public static Map<Integer, Integer> variantMap = new HashMap<>();
+    public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
 
     public BlockLogicOreCoal(Block<?> block, Block<?> parentBlock, Material material){
         super(block, material);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreDiamond.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreDiamond.java
index 1d13014cc..e25b350f6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreDiamond.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreDiamond.java
@@ -6,13 +6,14 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.WorldFeatureOre;
 
 import java.util.HashMap;
 import java.util.Map;
 
 public class BlockLogicOreDiamond extends BlockLogic
 {
-    public static Map<Integer, Integer> variantMap = new HashMap<>();
+    public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
     public BlockLogicOreDiamond(Block<?> block, Block<?> parentBlock, Material material)
     {
         super(block, material);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreGold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreGold.java
index 28905c573..2bb4211df 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreGold.java
@@ -6,13 +6,14 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.WorldFeatureOre;
 
 import java.util.HashMap;
 import java.util.Map;
 
 
 public class BlockLogicOreGold extends BlockLogic {
-    public static Map<Integer, Integer> variantMap = new HashMap<>();
+    public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
 
     public BlockLogicOreGold(Block<?> block, Block<?> parentBlock, Material material) {
         super(block, material);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreIron.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreIron.java
index 242dede8f..80a828668 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreIron.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreIron.java
@@ -6,13 +6,14 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.WorldFeatureOre;
 
 import java.util.HashMap;
 import java.util.Map;
 
 public class BlockLogicOreIron extends BlockLogic
 {
-    public static Map<Integer, Integer> variantMap = new HashMap<>();
+    public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
     public BlockLogicOreIron(Block<?> block, Block<?> parentBlock, Material material) {
         super(block, material);
         variantMap.put(parentBlock.id(), block.id());
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreLapis.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreLapis.java
index dbfcc4240..228954fe8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreLapis.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreLapis.java
@@ -7,13 +7,14 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.WorldFeatureOre;
 
 import java.util.HashMap;
 import java.util.Map;
 
 public class BlockLogicOreLapis extends BlockLogic
 {
-    public static Map<Integer, Integer> variantMap = new HashMap<>();
+    public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
     public BlockLogicOreLapis(Block<?> block, Block<?> parentBlock, Material material)
     {
         super(block, material);
